#include "prizm.h"
#include "CBP.h"

//---------------------------------------------------------------------------------------------

void Fkey_Icon(int n, int IconNo){
	unsigned int* iresult;	
	GetFKeyPtr( IconNo, &iresult);	//  .  		,white
	FKey_Display(n, iresult);
}

//---------------------------------------------------------------------------------------------
int GetFkeyColor(int n){
	unsigned short *VRAM=GetVRAMAddress();
	return VRAM[ n*64+2 +196*384 ];
}
int GetFkeyBackColor(int n){
	unsigned short *VRAM=GetVRAMAddress();
	return VRAM[ n*64+4 +196*384 ];
}

int Fkey_Line2( int n ){
	unsigned short *VRAM=GetVRAMAddress();
//	unsigned short *VRAM=PictAry[0];
	unsigned short c=GetFkeyColor(n);
	int x,y;
	for(x=n*64+4;x<n*64+60;x++){
		VRAM[x+213*384]=c;
		VRAM[x+214*384]=c;
	}
	for(y=196;y<=215;y++){
		for(x=n*64+63;x<n*64+65;x++){
			VRAM[x+y*384]=0xFFFF;	// white
		}
	}
}
int Fkey_Line3( int n ){
	unsigned short *VRAM=GetVRAMAddress();
//	unsigned short *VRAM=PictAry[0];
	unsigned short c=GetFkeyColor(n);
	int x,y;
	for(x=n*64+4;x<n*64+55;x++){
		VRAM[x+213*384]=c;
		VRAM[x+214*384]=c;
	}
	for(y=208;y<=214;y++){
		for(x=n*64+63-y+208;x<n*64+63;x++){
			VRAM[x+y*384]=0xFFFF;	// white
		}
	}
	for(y=196;y<=215;y++){
		for(x=n*64+63;x<n*64+65;x++){
			VRAM[x+y*384]=0xFFFF;	// white
		}
	}
}
int Fkey_ClearBox( int n ){
	unsigned short *VRAM=GetVRAMAddress();
//	unsigned short *VRAM=PictAry[0];
	unsigned short c=GetFkeyBackColor(n);
	int x,y;
	for(y=195;y<212;y++){
		for(x=n*64+20;x<n*64+40;x++){
			VRAM[x+y*384]=c;
		}
	}
}

void Fkey_Clear(int n) {
		unsigned int* iresult;	
		GetFKeyPtr(0x0, &iresult);	// 
		FKey_Display(n, iresult);
}

void Fkey_dispN(int n,char *buf) {
		unsigned int* iresult;	
		int x;
		GetFKeyPtr(0x0476, &iresult);	//  .  		,white
		FKey_Display(n, iresult);
		Fkey_ClearBox( n );
		PrintMiniXY(n*64+6, 7*24+5, (unsigned char *)buf, GetFkeyColor(n), COLOR_WHITE);
		Fkey_Line2( n );
}
void Fkey_dispN2(int n,char *buf) {
		unsigned int* iresult;	
		int x;
		GetFKeyPtr(0x0476, &iresult);	//  .  		,white
		FKey_Display(n, iresult);
		Fkey_ClearBox( n );
		PrintMiniXY(n*64+4, 7*24+5, (unsigned char *)buf, GetFkeyColor(n), COLOR_WHITE);
		Fkey_Line2( n );
}

void Fkey_dispR(int n,char *buf) {
		unsigned int* iresult;	
		int x;
		GetFKeyPtr(0x0334, &iresult);	//  t		,black/
		FKey_Display(n, iresult);
		Fkey_ClearBox( n );
		PrintMiniXY(n*64+2, 7*24+4, (unsigned char *)buf, COLOR_WHITE, GetFkeyColor(n) );
		Fkey_Line3( n );
}
void Fkey_DISPN(int n,char *buf) {
		unsigned int* iresult;	
		int x;
		GetFKeyPtr(0x0476, &iresult);	//  .  		,white
		FKey_Display(n, iresult);
		Fkey_ClearBox( n );
		PrintMiniXY(n*64+6, 7*24+5, (unsigned char *)buf, GetFkeyColor(n), COLOR_WHITE);
		Fkey_Line2( n );
}

void Fkey_DISPR(int n,char *buf) {
		unsigned int* iresult;	
		int x;
		GetFKeyPtr(0x0190, &iresult);	//  t		,black
		FKey_Display(n, iresult);
		Fkey_ClearBox( n );
		PrintMiniXY(n*64+2, 7*24+4, (unsigned char *)buf, COLOR_WHITE, GetFkeyColor(n) );
		Fkey_Line2( n );
}

void Fkey_dispNInit(int n) {
		unsigned int* iresult;
		GetFKeyPtr(0x005f, &iresult);	//INITIAL 	,white
		FKey_Display(3, iresult);
}		


void FkeyClear(int n) {
	Fkey_Icon(n, 0 );	// clear
}

void Fkey_dspRB(int n,char *buffer) {
	Fkey_DISPR( n, buffer); 
}

void Fkey_dispN_Aa(int n, char *buffer) {
	Fkey_dispN2(n,buffer);
//	Bdisp_AreaReverseVRAMx3( n*21+3, (7+0)*8+1, n*21+7, (7+0)*8+6);	// reverse
	Bdisp_AreaReverseVRAM( n*64+3, 192+3, n*64+20, 192+20 );	// reverse
}
void Fkey_dispN_aA(int n, char *buffer) {
	Fkey_dispN2(n,buffer);
//	Bdisp_AreaReverseVRAMx3( n*21+16, (7+0)*8+1, n*21+20, (7+0)*8+6);	// reverse
	Bdisp_AreaReverseVRAM( n*64+46, 192+3, n*64+60, 192+20 );	// reverse
}
